import SimpleOpenNI.*;
SimpleOpenNI kinect;

int closestValue; 
int closestX;
int closestY;

//declare global variables for the 
//previous x and y coordinates
//int previousX;
//int previousY;
float lastX;
float lastY;

boolean colorR = false;
boolean colorG = false;
boolean colorB = false;
boolean colorY = false;
boolean colorO = false;
boolean colorP = false;
boolean colorNone = false;

void setup(){

  size(640, 480);
  kinect = new SimpleOpenNI(this);
  kinect.enableDepth();
  
  //start with a black background
  background(0);
}

void draw(){
  closestValue = 8000; 
  kinect.update();
  
  int[] depthValues = kinect.depthMap();
  
   // for each row in the depth image
  for(int y = 0; y < 480; y++){ 
  // look at each pixel in the row
    for(int x = 0; x < 640; x++){
      
     //reverse x for mirror effect
      int reversedX = 640-x-1;
     // pull out the corresponding value from the depth array using reversedX
      int i = reversedX + y * 640; 
      int currentDepthValue = depthValues[i];
      
      //closest value within range 610 or 2 ft and 1525 or 5ft
      if(currentDepthValue > 610 && currentDepthValue < 1525 
          && currentDepthValue < closestValue){ 
        // save its value
        closestValue = currentDepthValue;
        // and save its position (both X and Y coordinates)
        closestX = x;
        closestY = y;
      }
    }
  }
  
  //linear interpolation, smooth transition between last point and new closest point
  float interpolatedX = lerp(lastX, closestX, 0.3f);
  float interpolatedY = lerp(lastY, closestY, 0.3f);
  
  //draw the depth image on the screen
  //for this project comment out to have a nicer drawing interface 
  //image(kinect.depthImage(),0,0);
  
  colorStart();
  keyPressed();
  
  
  //set the line drawing color to red
  colorR = true;
  strokeWeight(3);
  //draw a line from the previous point to the new closest one
  line(lastX, lastY, interpolatedX, interpolatedY);
  lastX = interpolatedX;
  lastY = interpolatedY;
}

void mousePressed(){
  //save image to file
  save("drawing.png");
  background(0);
}
  
  
